\FloatBarrier
\CopiedChapter{\footnotemark[1]\textsuperscript{,}\footnotemark[2]}{Formulation} 
\label{sec:formulation}
{

\renewcommand\picsDir{chapters/02_formulation_pics}

This chapter discusses the thermal model and introduces its time-stepping and Petrov-Galerkin space-time finite element formulations. The strong form of the nonlinear heat equation is defined as follows:
%
\begin{gather}
    \label{eq:formulation:strongform}
    \begin{split}
        c \dot{u} + \nabla \cdot (k \nabla u) = \; & \\[1ex]
                                           u  = \; & \\[1ex]
                                           u  = \; & \\[1ex]
                          n \cdot k \nabla u  = \; &
    \end{split}
    \begin{split}
        & f   \qquad \\[1ex]
        & u_0 \qquad \\[1ex]
        & g   \qquad \\[1ex]
        & h   \qquad 
    \end{split}
    \begin{split}
        & \text{on } \Omega = \mathcal{S} \times \mathcal{T} \\[1ex]
        & \text{on } \mathcal{S} \text{, at } t = t_0   \\[1ex]
        & \text{on } \Gamma_D             \\[1ex]
        & \text{on } \Gamma_N.            
    \end{split}
\end{gather}
The space-time domain $\Omega$ is the product of a $d$-dimensional spatial domain $\mathcal{S}$ \review{(considered time-invariant in this thesis)} and a time interval $\mathcal{T} = \left ( t_0, t_1 \right ]$; $u$ is the temperature, $\dot{u}$ and $\nabla{u}$ are the time derivative and spatial gradient of the temperature. Moreover, $c = c(u)$ and $k = k(u)$ are the heat capacity and the heat conductivity of the material, $f$ is the volumetric source function, $g$ and $h$ are the prescribed temperature and heat flux on the Neumann and Dirichlet boundaries $\Gamma_N$ and $\Gamma_D$, and $u_0$ is the initial condition. The Neumann and Dirichlet boundaries do not intersect ($\Gamma_D \cap \Gamma_N = \emptyset$), and they together form the spatial boundary during the simulation ($\Gamma_D \cup \Gamma_N = \partial \mathcal{S} \times \mathcal{T}$). The heat flux $c(u)$ is split into the density and specific heat capacity $c(u) = \rho c_s(u)$. In practice, $\rho$ also depends on the temperature, but it is assumed constant for simplicity. 

The following sections use the terms time slab, time slice, and time step to refer to parts of the space-time domain $\Omega$. A \textit{time slab} extracts a piece of $\Omega$ on a temporal subinterval $(t_i, t_{i + 1}] \in \mathcal{T}$ and is defined as $\mathcal{S} \times (t_i, t_{i + 1}]$. Time slabs have the same $d + 1$ dimensions as $\Omega$ and often refer to the subdomains on which individual space-time finite element problems are computed. In contrast, \textit{time slices} are $d$-dimensional spatial ''cuts'' through $\Omega$ at times $t_i$, defined as $\mathcal{S} \times t_i$. In specific contexts, a time slice or time slab may refer to the temperature field on the respective subdomain instead of the subdomain itself. A \textit{time step} is used in the context of time-stepping methods and consists of a pair of time values $(t_i, t_{i + 1})$ with a duration or time step length of $\Delta t_i = t_{i + 1} - t_i$. The time-stepping scheme discussed in Section~\ref{sec:formulation:timestepping} formulates a finite element problem for advancing a known (spatial) temperature field on time slice $t_i$ to the new temperature field on time slice $t_{i + 1}$. While time-stepping schemes operate on temperature slices at discrete times, space-time formulations (like the one introduced in Section~\ref{sec:formulation:spacetime}) interpolate the temperature field on space-time slabs.

\CopiedSection{\footnotemark[2]}{Laser model}
\label{sec:formulation:laser}


\begin{figure}[h]
  \centering%
  \includeTikz{}{volumetric_source}%
  \caption{Volumetric extension of the two-dimensional laser intensity profile in $z$-direction.}%
  \label{fig:formulation:laser:sketch}%
\end{figure}%


The laser heat input model \review{has a significant impact on} the quality of the thermal solution. Most current \gls*{LPBF} systems use lasers with wavelengths in the infrared spectrum, spatially distributed over a Gaussian profile. The laser intensity is therefore modeled as 
\begin{equation*}
    \Phi(x, y) = \frac{P}{2\pi\sigma^2} \exp { \left ( -\frac{x^2 + y^2}{2 \sigma^2} \right ) },
\end{equation*}
where $P$ is the total power of the laser and $\sigma$ is the width of the laser beam shape (often given as $D4\sigma = 4\sigma$). The coordinate system is chosen so that the build plate and subsequent layers lie in the $x-y$ plane, and $z$ is the vertical direction parallel to the laser beam. Other shapes are possible and currently being investigated for improving the process quality and productivity, for example, in~\textcite{Gruenewald2021}. In addition to the laser shape, the laser path $p : t \to (x, y, z)$ is given after slicing the geometric model and scanning the interior areas.

When encountering a metal surface, the electromagnetic waves are partially reflected and absorbed, depending on the absorptivity of the material. With higher absorptivities, more radiant energy of the electromagnetic waves is absorbed and converted into thermal energy on the surface of the material. The absorptivity changes with factors such as temperature, surface roughness, and angle of incidence, but these effects are often condensed into a single absorptivity $\nu$. For low temperatures and flat substrate surfaces, the heat input can be imposed as a distributed heat flux on the top surface with 
\begin{equation} \label{eq:formulation:laser:intensity2D}
    h(x, y) = \nu \, \Phi(x - p_x(t), y - p_y(t)).
\end{equation}

Such surface models deliver increasingly poorer results after the laser power is high enough to reach melting and, eventually, boiling temperatures below the laser spot. Once evaporation becomes dominant and recoil pressure-induced depressions and keyholes form, the effective absorptivities dramatically increase, as shown by~\textcite{Trapp2017}, for example. Besides absorbing more energy, the heat enters below the original top surface, which has been melted and pushed into the substrate by the recoil pressure. This increases the depth of the melt pool more than a surface heat source model can predict, even when adjusting the effective absorptivity accordingly.

Capturing these effects requires a detailed model that includes fluid flow and evaporation. However, choosing a volumetric heat input can improve the results from thermal models if there is not enough recoil pressure for keyholing. By allowing heat to be introduced over some depth in the substrate, the melt pool depth can be calibrated to a given setup. To this end, a penetration intensity function $\mathcal{I}(z)$ is selected, for example
\begin{equation} \label{eq:formulation:laser:penetration}
    \mathcal{I}(z) = \frac{1}{\sqrt{2\pi}\sigma_z} \exp { \left ( -\frac{z^2}{2 \sigma_z^2} \right ) },
\end{equation}
where $\sigma_z$ is the penetration depth that can be chosen in relation to the laser parameters. Then, the volumetric source function $f$ is defined as
\begin{equation} \label{eq:formulation:laser:volumesource}
    f(x, y, z, t) = \nu \, \mathcal{I}(z - p_z(t)) \, \Phi(x - p_x(t), y - p_y(t)).
\end{equation}
%
Figure~\ref{fig:formulation:laser:sketch} sketches the combination of $\Phi$ and $\mathcal{I}$ into a volumetric heat source.
Allowing the laser to penetrate the substrate to some degree is also beneficial when using a continuum approach to model metal powder. On this scale, resolving individual grains is not feasible, but the natural penetration of the laser light into the powder is still important. As \textcite{Gusarov2009} suggest, a volumetric heat source with an extension into the material similar to~\eqref{eq:formulation:laser:penetration} can account for this effect in a homogenized way. Similar models have been analyzed by~\textcite{Zhang2018, Kollmannsberger2019}, and \textcite{Shahabad2020}.

\CopiedSection{\footnotemark[2]}{Phase change model}
\label{sec:formulation:phasechange}

\begin{figure}[hbt]
  \begin{minipage}[b]{0.5\linewidth} 
    \includeTikz{width=\linewidth, height=0.65\linewidth}{phase_change_function_d0}
    %\subcaption{Classical time-stepping}
  \end{minipage}%
  \hfill
  \begin{minipage}[b]{0.5\linewidth} 
    \includeTikz{width=\linewidth, height=0.65\linewidth}{phase_change_function_d1}
  \end{minipage}%
  \caption{Phase change regularization between solid and liquid states. \reprintedB}
  \label{fig:formulation:phasechange:regularization} 
\end{figure}

The heat capacity of a material specifies how much energy is required to increase its temperature by a fixed amount. The same energy is released when the material cools down to the original temperature. This becomes quite extreme during phase transitions, where a significant amount of latent heat must be \review{spent in} completing the phase transition before the temperature can rise again. For simulating \gls*{LPBF} processes, the latent heat of fusion is essential for obtaining more realistic temperatures in the melt pool. The otherwise higher temperatures and temperature gradients lead to an artificially high diffusion of heat that results in overestimating the melt pool width and depth and underestimating the melt pool length. While the melting of pure metals is isothermal, the alloys commonly used in \gls*{LPBF} usually melt over a temperature range that depends on the composition.

\begin{figure}[h!]
  \begin{minipage}[b]{0.475\linewidth}
    \centering
    \includeJpg{width=\linewidth}{phasechange_xy_solution}
    
    \vspace{0.5em}
    \includeJpg{width=\linewidth}{phasechange_xz_solution}
    
    \vspace{0.5em}
    \includeTikz{}{phasechange_colorbar_solution}%
    \subcaption{Temperature [\si{\celsius}]}
    \label{fig:formulation:phasechange:spatialplot:a} 
  \end{minipage}%
  \hfill
  \begin{minipage}[b]{0.475\linewidth}
    \centering  
    \includeJpg{width=\linewidth}{phasechange_xy_source}
    
    \vspace{0.5em}
    \includeJpg{width=\linewidth}{phasechange_xz_source}
    
    \vspace{0.5em}
    \includeTikz{}{phasechange_colorbar_source}%
    \subcaption{Volumetric heat source [\si{\watt\per\cubic\meter}]}
    \label{fig:formulation:phasechange:spatialplot:b} 
  \end{minipage}%
  \hspace{0.2em}
  \raisebox{4.52cm}{\rotatebox[origin=t]{-90}{Top view\hspace{1.75cm}Side view}}
  
  \vspace{1.5em}
  
  \begin{minipage}[b]{0.475\linewidth}
    \centering  
    \includeJpg{width=\linewidth}{phasechange_xy_phasefunction}
    
    \vspace{0.5em}
    \includeJpg{width=\linewidth}{phasechange_xz_phasefunction}
    
    \vspace{0.5em}
    \includeTikz{}{phasechange_colorbar_phasefunction}%
    \subcaption{Phase function $f_{pc} \circ u$ [--]}
    \label{fig:formulation:phasechange:spatialplot:c} 
  \end{minipage}%
  \hfill
  \begin{minipage}[b]{0.475\linewidth}
    \centering  
    \includeJpg{width=\linewidth}{phasechange_xy_capacity}
    
    \vspace{0.5em}
    \includeJpg{width=\linewidth}{phasechange_xz_capacity}
    
    \vspace{0.5em}
    \includeTikz{}{phasechange_colorbar_capacity}%
    \subcaption{Apparent heat capacity $c \circ u$ [\si{\joule\per\cubic\meter\per\celsius}].}
    \label{fig:formulation:phasechange:spatialplot:d} 
  \end{minipage}%
  \hspace{0.2em}
  \raisebox{4.52cm}{\rotatebox[origin=t]{-90}{Top view\hspace{1.75cm}Side view}}
  
  \caption{Phase change between $u_s = \SI{1290}{\celsius}$ and $u_l = \SI{1350}{\celsius}$ with $S = 1$. The laser travels from right to left on top of an IN625 metal plate (see Section~\ref{sec:results:amb}).}
  \label{fig:formulation:phasechange:spatialplot} 
\end{figure}

There are many ways of including the latent heat of fusion into a finite element simulation. In particular, single-field approaches that do not introduce two separate solution fields for the solid and liquid phases are attractive as they are comparably simple to implement. The primary solution can either be the temperature or the enthalpy, from which the temperature can be recovered afterwards. Temperature formulations are attractive for non-isothermal phase changes where the transition can be described continuously. To this end, a phase change function $f_{\text{pc}}(u)$ is defined, with a value of zero for fully solidified material and one for fully liquid material. The interpolation between the solid temperature $u_s$ and the liquid temperature $u_l$ is typically done using a continuous function, for example, 
\begin{equation} \label{eq:formulation:phasechange:fpc}
f_{\text{pc}} ( u ) =  \frac{1}{2} \left ( \tanh \left ( \frac{u - u_m}{u_{\sigma}} \right ) + 1 \right ),
\end{equation}
where $u_m$ and $u_{\sigma}$ are the melting temperature and the width of the phase change, defined as
\begin{equation}
u_m = \frac{u_l + u_s}{2} \qquad u_{\sigma} = S \, \frac{u_l - u_s}{2}.
\end{equation}
The regularization parameter $S$ gives additional control over the smoothness of the phase change, which is later used to improve the numerical behavior of the problem. The formulation of~\eqref{eq:formulation:phasechange:fpc} smoothly transitions between the solid and liquid states, containing most of the latent heat of fusion between $u_s$ and $u_l$. The first and second derivatives of $f_{pc}$ with respect to temperature are:
\begin{align*}
f'_{\text{pc}}(u) &= \frac{1}{2 u_{\sigma}} \left ( 1 - \tanh \left ( \frac{u - u_m}{u_{\sigma}} \right )^2 \right ) \\[1ex]
f''_{\text{pc}}(u) &= \frac{1}{u_{\sigma}^2} \tanh \left ( \frac{u - u_m}{u_{\sigma}} \right ) \left ( \tanh \left ( \frac{u - u_m}{u_{\sigma}} \right )^2 - 1 \right ).
\end{align*}
Figure~\ref{fig:formulation:phasechange:spatialplot:a} shows a temperature field computed from the volumetric source in Figure~\ref{fig:formulation:phasechange:spatialplot:b}, using the material and laser parameters of Section~\ref{sec:results:amb}. The composition $u \circ f_{pc}$ of the temperature $u$ and the phase change function $f_{pc}$ evaluates to one inside the melt pool and transitions to zero elsewhere in a very narrow zone, as Figure~\ref{fig:formulation:phasechange:spatialplot:c} shows.

Together with the latent heat of fusion $L$ of the material, the heat equation~\eqref{eq:formulation:strongform} is augmented with a latent heat term that stores the energy of the phase change, and hence its time derivative acts as a heat source or sink:
\begin{equation} \label{eq:formulation:phasechange:separate}
\rho c_s \dot{u} + \rho L \dot{f}_{\text{pc}}+ \nabla \cdot (k \nabla u) = f
\end{equation}
By applying the chain rule 
\begin{equation*}
\dot{f_{\text{pc}}} = \frac{\partial f_{\text{pc}}(u)}{\partial t} = \frac{\mathrm{d} f_{\text{pc}}}{\mathrm{d} u} \frac{\partial u}{\partial t} = f'_{\text{pc}} \dot{u},
\end{equation*}
the standard form of the heat equation~\eqref{eq:formulation:strongform} can be recovered:
\begin{equation} 
\label{eq:formulation:phasechange:apparent}
(\rho c_s + \rho L f'_{\text{pc}}) \, \dot{u} + \nabla \cdot (k \nabla u) = f.
\end{equation}
In~\eqref{eq:formulation:phasechange:apparent}, $c(u) = \rho c_s(u) + \rho L f'_{\text{pc}}(u)$ is called the apparent heat capacity. 
This formulation is particularly attractive as it can be used with existing heat equation solvers and only requires modifying the heat capacity. The derivative of $f_{pc}$ adds a sharp spike around the melting temperature, as Figure~\ref{fig:formulation:phasechange:spatialplot:d} shows. This makes the numerical quadrature of the finite element integrals challenging, especially since thermal models for \gls*{LPBF} often use only few elements to discretize the melt pool volume. Figure~\ref{fig:formulation:phasechange:spatialplot}, however, uses \SI{39x13x7}{} third-order finite elements across a melt pool with a size of about \SI{400x130x35}{\micro\meter}. Reducing the number of elements in this discretization requires further regularization of $f_{pc}$ (by increasing $S$) to smooth the spike in $c$. 

The formulation of~\eqref{eq:formulation:phasechange:separate} allows time-stepping schemes to introduce a separate finite difference approximation for $\dot{f}_{pc}$. Such schemes offer improved stability over formulations based on~\eqref{eq:formulation:phasechange:apparent}, as discussed in Section~\ref{sec:formulation:timestepping}. Technically,~\eqref{eq:formulation:phasechange:separate} can be used for isothermal phase transitions, but in practice, it still may be necessary to regularize the discontinuous phase change function $f_{\text{pc}}$. Because~\eqref{eq:formulation:phasechange:separate} does not naturally transfer to a single field space-time formulation, Section~\ref{sec:formulation:spacetime} uses the apparent heat capacity version~\eqref{eq:formulation:phasechange:apparent} instead.

\CopiedSection{\footnotemark[1]}{Time-stepping finite element formulation}
\label{sec:formulation:timestepping}

This section discusses a time-stepping finite element formulation of~\eqref{eq:formulation:phasechange:separate} with dynamic refinement and derefinement to compare to the space-time formulation introduced in Section~\ref{sec:formulation:spacetime}, which is the main focus of this thesis. The derivation follows closely the work presented by~\textcite{Celentano1994} but uses Rothe's method, where time is discretized first, instead of using the method of lines, where space is discretized first. The formulation in terms of spatial functions on the sequence of time slices allows the subsequent spatial discretization to change between time steps, which is crucial for using dynamic $hp$-refinement with a time-stepping scheme. Such approaches are commonly used in adaptive finite elements for time-dependent problems \parencite[][]{Kollmannsberger2021, Kopp2022a}. This thesis uses the Wilson-$\theta$ scheme to discretize in time, which results in the conditionally stable, explicit, first-order accurate Forward-Euler scheme for $\theta = 0$, the unconditionally stable, implicit, second-order accurate Crank-Nickolson scheme for $\theta = 1/2$, and the unconditionally stable, implicit, first-order accurate Backward-Euler scheme for $\theta = 1$. Importantly, these characteristics hold only for linear problems under certain regularity assumptions.

%Check the formulation paper: Two versions of the Wilson-θ time integration method
% Change i and n and make c theta sentences consistent.

A time-stepping scheme subdivides the time interval $\mathcal{T}$ into a sequence of time steps from $t^n$ to $t^{n + 1}$ and sequentially advances the solution on the associated time slices. Within a time step, the time derivatives are approximated as 
\begin{equation*}
\rho c_s \frac{\partial u}{\partial t} \approx \rho c_s^{n + \theta} \, \frac{u^{n+1}-u^n}{\Delta t} \qquad \text{and} \qquad 
\rho L \frac{\partial f_{\text{pc}}}{\partial t} \approx \rho L \, \frac{f_{\text{pc}}^{n+1} - f_{\text{pc}}^{n}}{\Delta t},
\end{equation*}
where the $n$ and $n + 1$ superscripts represent time slices at $t^n$ and $t^{n + 1}$, and the superscript $n + \theta$ indicates interpolation at $\theta$ between the values at $t^n$ and $t^{n + 1}$:
\begin{equation*}
c^{n + \theta} = (1 - \theta) \, c^n + \theta \, c^{n+1}.
\end{equation*}
The remaining terms of~\eqref{eq:formulation:phasechange:separate} without a time derivative are interpolated at $t^{n + \theta}$ to obtain the following time discretization:
\begin{equation} \label{eq:formulation:timestepping:strongform}
\rho c_s^{n + \theta} \, \frac{u^{n+1} - u^n}{\Delta t} + \rho L \frac{f_{\text{pc}}^{n + 1} - f_{\text{pc}}^n}{\Delta t} - \nabla \cdot \big [ k \, \nabla u \big ]^{n + \theta} = f^{n + \theta},
\end{equation}
where
\begin{align*}
&\big [ k \, \nabla u \big ]^{n + \theta} = (1 - \theta) \, k(u^n) \, \nabla u^n + \theta \, k(u^{n+1}) \, \nabla u^{n+1}, \\[0.5em]
&f^{n + \theta} = (1 - \theta) \, f^n + \theta f^{n + 1}.
\end{align*}
The weak form of~\eqref{eq:formulation:timestepping:strongform} then reads: Find $u^{n + 1} \in u^{n + 1}_g + H^1_0(\mathcal{S})$ such that
\begin{multline} \label{eq:formulation:timestepping:weakform}
\int_{\mathcal{S}} \frac{\rho c_s^{n + \theta}}{\Delta t} \, w \, \left ( u^{n+1} - u^n \right ) + \frac{\rho L}{\Delta t} \, w \, \left ( f_{\text{pc}}^{n + 1} - f_{\text{pc}}^n \right ) + \nabla w \cdot \big [ k \, \nabla u \big ]^{n + \theta} \, \text{d}\mathcal{S}\\[0.5em]
= \int_{\mathcal{S}} w f^{n + \theta} \, \text{d} \mathcal{S} + \int_{\,\mathcal{N}} w h^{n + \theta} \, \text{d} \,\mathcal{N},
\end{multline}
holds for all $w \in H^1_0(\mathcal{S})$. In~\eqref{eq:formulation:timestepping:weakform}, $\,\mathcal{N}$ refers to the spatial component of the Neumann boundary $\Gamma_N$, such that $\,\mathcal{N} \times \mathcal{T} = \Gamma_N$, and $u^{n + 1}_g \in H^1(\mathcal{S})$ is a smooth extension of the Dirichlet function $g$ into the domain interior. The Sobolev space $H^1_0(\mathcal{S})$ contains real-valued functions defined on $\mathcal{S}$ with zero values on the Dirichlet boundary and weakly defined first derivatives. Sobolev spaces state the necessary continuity conditions and are essential in the mathematical analysis of finite elements. Selecting a finite element subspace $W^{n, h} \subset H^1_0$ for each time slice yields the interpolations $u^n_h = \sum N^n_i \hat{u}^n_i \in W^{n, h}$, where $\hat{u}^n_i$ are the space- and time-independent coefficients (degrees of freedom) for time slice $n$. As the time slices are discretized independently, the finite element meshes may differ, enabling the use of dynamic mesh refinement. In one time step, the basis $\{ N^n_i \}$ for the current time slice and the basis $\{ N^{n + 1}_i\}$ for the next time slice do not have to coincide. Similarly, the number of coefficients may differ between the discretizations of different time slices. From now on, the superscript in $N^{n + 1}_i$ is omitted to simplify the notation. Using again the same test as trial functions allows to obtain the discrete weak residual:
\begin{multline} \label{eq:formulation:timestepping:discreteweakresidual}
R_i^n(\hat{u}^{n + 1}) = \int_{\mathcal{S}} \frac{\rho c_s^{n + \theta}}{\Delta t} \, N_i \, \left ( u_h^{n+1} - u_h^n \right ) + \frac{\rho L}{\Delta t} \, N_i \, \left ( f_{\text{pc}}^{n + 1} - f_{\text{pc}}^n \right ) + \nabla N_i \cdot \big [ k \, \nabla u_h \big ]^{n + \theta} \, \text{d} \mathcal{S} \\[0.5em]
- \int_{\mathcal{S}} N_i f^{n + \theta} \, \text{d} \mathcal{S} - \int_{\,\mathcal{N}} N_i h^{n + \theta} \, \text{d} \,\mathcal{N}.
\end{multline}
The material parameters $c_s$ and $k$ and the phase change function $f_{\text{pc}}$ are now evaluated using the discrete solution. Again the $n + \theta$ superscripts indicate an interpolation at $\theta$ between the evaluations at $t^n$ and $t^{n + 1}$. Constructing an iterative scheme with second-order convergence to find the coefficients $\hat{u}^{n + 1}$ that solve $R^n_i(\hat{u}^{n + 1}) = 0$ requires deriving the linearization $\partial R^n_i / \partial \hat{u}^{n + 1}_j$. Using the intermediate results
\begin{equation*}
    \frac{\partial u^{n + 1}_h}{\partial \hat{u}^{n + 1}_j} = N_j, \qquad \frac{\partial u^{n}_h}{\partial \hat{u}^{n + 1}_j} = 0,
\end{equation*}
and, therefore,
\begin{alignat*}{2}
    &\frac{\partial c_s^{n + \theta}}{\partial \hat{u}^{n + 1}_j} &&= (1 - \theta) \, c_s'^{\,n} \frac{\partial u^{n}_h}{\partial \hat{u}^{n + 1}_j} + \theta \, c_s'^{\,n + 1} \frac{\partial u^{n + 1}_h}{\partial \hat{u}^{n + 1}_j} = \theta \, c_s'^{\,n + 1} N_j, \\[0.8em]
    &\frac{\partial }{\partial \hat{u}^{n + 1}_j} \Big [ c_s^{n + \theta} \, \left ( u_h^{n+1} - u_h^n \right ) \Big ] &&= c_s^{n + \theta} \,\frac{\partial u^{n + 1}_h}{\partial \hat{u}^{n + 1}_j}  + \frac{\partial c_s^{n + \theta}}{\partial \hat{u}^{n + 1}_j} \big ( u_h^{n+1} - u^n_h \big )
    \\[0.8em]
    &&&= c_s^{n + \theta} \, N_j + \theta \, c_s'^{\,n + 1} \big ( u_h^{n+1} - u^n_h \big ) N_j
    \\[0.8em]
    &\frac{\partial }{\partial \hat{u}^{n + 1}_j} \Big [ f_{\text{pc}}^{n + 1} - f_{\text{pc}}^n \Big ] &&= f'^{\,n + 1}_{\text{pc}} \, \frac{\partial u^{n + 1}_h}{\partial \hat{u}^{n + 1}_j} = f'^{\,n + 1}_{\text{pc}} N_j
    \\[0.5em]
    &\frac{\partial }{\partial \hat{u}^{n + 1}_j} \Big [ k \, \nabla u_h \Big ]^{n + \theta} &&= \theta k^{n + 1} \frac{\partial \left ( \nabla u^{n + 1}_h \right )}{\partial \hat{u}^{n + 1}_j}  + \theta \, k'^{\,n + 1} \, \frac{\partial u^{n + 1}_h}{\partial \hat{u}^{n + 1}_j} \nabla u^{n + 1}_h 
    \\[0.8em]
    &&&= \theta k^{n + 1} \nabla N_j + \theta \, k'^{\,n + 1} \, N_j \nabla u^{n + 1}_h , \\[-1em]
\end{alignat*}
%
the consistent linearization of~\eqref{eq:formulation:timestepping:discreteweakresidual} becomes: 
%
\begin{equation} \label{eq:formulation:timestepping:linearization}
    \begin{aligned}
        T^n_{ij}(\hat{u}^{n + 1}) = &\int_{\mathcal{S}} \frac{\rho}{\Delta t} \left ( c_s^{n + \theta} + \theta \, c_s'^{\,n + 1} \big ( u_h^{n+1} - u^n_h \big ) + L f'^{\,n + 1}_{\text{pc}} \, \right ) N_i N_j \, \text{d} \mathcal{S} \\[0.5em]
        &+ \int_{\mathcal{S}}  \theta \, \nabla N_i \cdot \left ( k^{n + 1} \nabla N_j + k'^{\,n + 1} \nabla u^{n + 1}_h N_j \right ) \, \text{d} \mathcal{S}.
    \end{aligned}
\end{equation}
%
The second ''stiffness'' term in~\eqref{eq:formulation:timestepping:linearization} involving the derivative of the conductivity $k'$ can be omitted to maintain symmetry of the linear systems. This is often done and does not reduce the convergence of the nonlinear iterations for the problems considered here by much; however, for highly nonlinear conductivities, it may be needed. Now, a nonlinear iteration scheme is constructed using~\eqref{eq:formulation:timestepping:discreteweakresidual} and~\eqref{eq:formulation:timestepping:linearization}, starting with an initial guess $\hat{u}^{n + 1, \, 0}$ for the coefficients of time $n + 1$:
\begin{align*}
    &\hat{u}^{n + 1, \, k + 1} =\hat{u}^{n + 1, \, k} + \Delta \hat{u}^{n + 1, \, k} \\[0.3em]
    &T^n_{ij}(\hat{u}^{n + 1, \, k}) \, \Delta \hat{u}^{n + 1, \, k}_j = -R^n_{i}(\hat{u}^{n + 1, \, k}).
\end{align*}

The computations in this thesis use the symmetric linearization outlined in this section. Moreover, the $L^2$ projection of $u^{n}_h$ onto the basis of time $n + 1$ is used as an initial guess for the nonlinear iterations. This projection could also be used in the finite element integrals~\eqref{eq:formulation:timestepping:linearization} and~\eqref{eq:formulation:timestepping:discreteweakresidual} instead of evaluating $u^{n}_h$ using the old finite element basis. However, such a linear $L^2$ projection does not conserve energy if the heat capacity depends on temperature. 

%The representation of the solution in two time slices requires two finite element bases (for $t^n$ and for $t^{n + 1}$) to assemble the equation system resulting from one time step. Furthermore, $C^\infty$ continuity is ensured on all integration cells by distributing Gauss-Legendre points on the intersection of both grids. The coinciding base meshes of the hierarchical refinements built in Chapter~\ref{sec:mlhp} facilitate the construction of such intersections. Finer elements of one mesh are always fully contained in the coarser element of the other mesh and a shared parent of both cells can always be identified. 

The representation of the solution in two time slices requires two finite element bases (for $t^n$ and for $t^{n + 1}$) to assemble the equation system resulting from one time step. \review{The two bases are constructed on different meshes when dynamically refining and derefining, resulting in element interfaces located inside an element of the next mesh. The Gauss-Legendre quadrature used to integrate the finite element integrals is designed to integrate polynomials exactly but delivers poor results when integrating functions with low regularity. To prevent integrating over the $C^0$ continuous element interfaces of the previous mesh, an integration cell may not overlap more than one element per time slice mesh. The hierarchical refinements built in Chapter~\ref{sec:mlhp} allow local solution features to be resolved using the same base mesh in all time steps to capture the coarse scales, guaranteeing that finer elements of one mesh are always fully contained in the coarser element of the other mesh. Using this structure, the integration cells to assemble an element of the $t^{n + 1}$ mesh are found by first identifying the corresponding cell in the $t^{n}$ mesh. This corresponding $t^n$ cell either is either coarser, identical, or overlayed by several finer cells. The identical case is trivial and does not require special treatment. If the $t^n$ cell is coarser, the quadrature points are distributed on the $t^{n + 1}$ element and mapped to the $t^n$ cell. If the $t^n$ cell is a coarse parent of finer elements, the quadrature points are distributed on the finer elements and mapped to the coarse parent (corresponding to the $t^{n + 1}$ element). The hierarchical mesh and its data structure are discussed in Section~\ref{sec:mlhp:datastructure}.} 
%The hierarchical refinements built in Chapter~\ref{sec:mlhp} always refine the same base meshes, facilitating the construction of such integration meshes as finer elements of one mesh are always fully contained in the coarser element of the other mesh and a shared parent of both cells can always be identified.

\CopiedSection{\footnotemark[2]}{Continuous space-time weak formulation}
\label{sec:formulation:spacetime}

% https://finite-element.github.io/L4_feprobs.html
% https://link.springer.com/book/10.1007/978-0-387-75934-0

% https://en.wikipedia.org/wiki/Lions%E2%80%93Lax%E2%80%93Milgram_theorem
% https://math.stackexchange.com/questions/4071883/lax-milgram-and-inf-sup
% https://www.mi.fu-berlin.de/en/math/groups/ag-numerik/dateien_summer_2018/Numerik3_Skript-1.pdf

Instead of advancing the solution slice-by-slice, space-time finite elements discretize the entire space-time domain with a $d + 1$ dimensional finite element interpolation. Multiplying~\eqref{eq:formulation:strongform} by a test function $w$ and integrating by parts gives the following space-time weak form:

\noindent Find $u \in u_b + U_0$, such that
\begin{equation} 
    \label{eq:formulation:spacetime:weakform1}
    \int_{\Omega} w \, c \dot{u} + \nabla w \cdot \, k \nabla u \; \text{d}\Omega = \int_{\Omega} w f \; \text{d}\Omega + \int_{\Gamma_N} w \, h \; \text{d} \Gamma_N \qquad \forall w \in W_0,
\end{equation}
where $u_b \in U$ satisfies the initial and Dirichlet conditions.
The test and trial spaces $U$ and $W$ incorporate the conditions on the functions $w$ and $u$ that allow the terms in~\eqref{eq:formulation:spacetime:weakform1} to be integrated in space and time. To integrate the second term, the spatial gradients of $w$ and $u$ must be defined (weakly), and their dot product must be integrable over space and time. While this condition is sufficient for $w$, the time derivative in the first term leads to the additional condition that $\dot{u}$ must be defined (at least in an inner product with $w$). Because the test and trial spaces differ, the method is of Petrov-Galerkin type.

The mathematical analysis of space-time finite elements is often based on Bochner spaces of functions from the time interval $\mathcal{T}$ into a spatial Sobolev space $H^s(\mathcal{S})$. In particular, the test and trial spaces
\begin{alignat*}{3}
&W &&= L^2(\mathcal{T}; H^1(\mathcal{S})) \\
&U &&= L^2(\mathcal{T}; H^1(\mathcal{S})) \cap H^1(\mathcal{T}; H^{-1}(\mathcal{S}))
\end{alignat*}
define the existence conditions for~\eqref{eq:formulation:spacetime:weakform1}. The test space $W$ contains functions that for any time $t \in \mathcal{T}$ yield a spatial function in $H^1(\mathcal{S})$, such that its spatial energy norm ($H^1$-norm on $\mathcal{S}$) is square integrable in time ($L^2$-norm on $\mathcal{T}$). The trial space additionally requires that spatial slices of the time derivative are from $H^{-1}$ and that their norm is square integrable in time. In other words, the second condition requires $\dot{u}$ to be defined in space, at least in the sense of distributions. It may contain a Dirac delta, for example, since the test functions $w$ in the product $w \dot{u}$ are continuous in space, as they are from $H^1(\mathcal{S})$, and the product with an element from the dual space $H^{-1}(\mathcal{S})$ is well-defined in an integral sense. Moreover, the restrictions of $W$ and $U$ to functions that are zero on the Dirichlet boundary are again denoted by $W_0$ and $U_0$.%, where functions in $U_0$ are also zero at the initial time.}

A weak form is well-posed if it has a unique solution that can be bounded by the source term \parencite[also called stability property; see][, introduction of Chapter 2]{Ern2004}. The weak form of linear problems can be written as $b(u, w) = l(w)$, where $b$ is called a bilinear form and $l$ a linear functional. For elliptic problems, the well-posedness of a weak form follows from the Lax-Milgram theorem that requires $b(u, w)$ to be bounded and coercive (positive-definite). Unfortunately, Lax-Milgram cannot be used here, as~\eqref{eq:formulation:spacetime:weakform1} is parabolic, and the test and trial spaces in the bilinear form are different; instead, an inf-sup stability condition must be proven. In classic linear elasticity for structural mechanics, such inf-sup conditions can be interpreted as requiring that for every non-zero displacement field (trial function), there is at least one admissible virtual displacement (test function) that causes a non-zero virtual work (the result of evaluating the bilinear form). Of course, this context does not apply to the space-time formulation of the heat equation, but inf-sup conditions do not need such engineering interpretations. They are the continuous equivalent of requiring the (stiffness) matrix to be invertible in the discrete setting \parencite[see][, Remark 2.23]{Ern2004}. \Textcite{Schwab2009} show that~\eqref{eq:formulation:spacetime:weakform1} is well-posed, permitting a unique solution $u$. Interestingly, stationary advection-diffusion problems have a very similar structure with a first and second derivative. However, the standard weak form is coercive as the diffusion acts in all directions.


\CopiedSection{\footnotemark[2]}{Space-time finite element discretization}
\label{sec:formulation:petrovgalerkin}

\input{chapters/tikzhelper.tex}

A finite element approximation of \eqref{eq:formulation:spacetime:weakform1} constructs discrete subspaces $U^h \subset U$ and $W^h \subset W$ on a finite element mesh. In contrast to the discretization of the time slices in Section~\ref{sec:formulation:timestepping}, the mesh and the basis functions are now $d + 1$ dimensional as they include the temporal dimension. Unfortunately, the additional complexity related to the continuous parabolic problem transfers to the discrete setting. For elliptic problems, the well-posedness result of the Lax-Milgram theorem transfers to the discrete setting \parencite[, Proposition 2.19]{Ern2004}, and the natural choice $W^h = U^h$ even yields the best approximation for symmetric bilinear forms \parencite[, Chapter 4.1]{Hughes2000}. For parabolic problems, stability must be proven again for each pair of discrete spaces $U^h$ and $W^h$, and there is no obvious choice, such as selecting $W^h = U^h$ for elliptic problems.


\begin{figure}[h]
\centering
\hspace{0.5cm}
\begin{minipage}[b]{0.35\textwidth}
  \includeTikz{width=\textwidth}{matrixstructure_sketch}
\end{minipage}
\begin{minipage}[b]{0.4\textwidth}
  \hfill
  \includePng{width=0.75\textwidth}{matrixstructure_solution}%
  \vspace{0.22cm}\hspace{0.4cm}
\end{minipage}
\includeTikz{}{matrixstructure_solution_colorbar}%
\caption{\review{Problem setup for comparing the matrix structure of three test bases and their numerical solution on a $3 \times 3$ mesh.}}
\label{fig:formulation:petrovgalerkin:matrixstructure}
\end{figure}

\begin{figure}[ht!]
\includeTikz{}{spacetime_sketch_bubnov_top}

\vspace{0.7cm}

\includeTikz{}{spacetime_sketch_bubnov_shapes}
\caption{Space-time $C^0$ basis functions from the tensor-product of piecewise linear ''hat'' functions after imposing a zero initial condition on the bottom edge and Dirichlet condition on the left edge.}
\label{fig:formulation:petrovgalerkin:bubnov}
\end{figure}

\begin{figure}[ht!]
\includeTikz{}{spacetime_sketch_petrov1_top}

\vspace{0.7cm}

\includeTikz{}{spacetime_sketch_petrov1_shapes}
\caption{Tensor-product of piecewise linear ''hat'' functions in space with piecewise constant, discontinuous functions in time.}
\label{fig:formulation:petrovgalerkin:petrov1}
\end{figure}

\begin{figure}[ht!]
\includeTikz{}{spacetime_sketch_petrov2_top}

\vspace{0.7cm}

\includeTikz{}{spacetime_sketch_petrov2_shapes}
\caption{Time derivatives of the standard $C^0$ basis functions from Figure~\ref{fig:formulation:petrovgalerkin:bubnov}, spanning the same space as the basis in Figure~\ref{fig:formulation:petrovgalerkin:petrov1}.}
\label{fig:formulation:petrovgalerkin:petrov2}
\end{figure}

\begin{figure}[ht!]
%\centering

\includeTikz{}{spacetime_system_bubnov}%

\vspace{0.5cm}%

\includeTikz{}{spacetime_system_petrov1}%

\vspace{0.5cm}%

\includeTikz{}{spacetime_system_petrov2}%

\caption{Linear system comparison for zero temperatures on the initial and left boundaries.}
\label{fig:formulation:petrovgalerkin:systems}
\end{figure}

This section compares two space-time finite element methods that use standard continuous piecewise polynomials to represent the solution, but their test spaces are different. \review{Figure~\ref{fig:formulation:petrovgalerkin:matrixstructure} shows a simple linear heat problem with one spatial and one temporal dimension. Its discretization \review{in Figure~\ref{fig:formulation:petrovgalerkin:bubnov}} uses} the space-time tensor-product of three piecewise linear ''hat'' functions in space and time, resulting in nine basis functions $N_i(x, t)$. This thesis uses such standard finite element basis functions to span the trial spaces in space and time, although local refinements and high-order basis functions are added later to improve the approximation properties. The first method uses the same test and trial functions, which is intuitive and easy to implement in existing finite element codes. \Textcite{Steinbach2015} derives the discrete stability of this method in a mesh-dependent norm and shows first and second-order convergence for $p = 1$ and $p = 2$ in the energy norm ($H^1$ norm in space, $L^2$ norm in time). However, unlike in symmetric, second-order problems, continuity in time is not necessary for the test functions. The second method tests with piecewise constant functions supported only on one element instead of connecting pairs of linear shape functions in time to continuous basis functions with support on two elements. This approach was introduced by~\textcite{Aziz1989} and is later referred to as the continuous Galerkin-Petrov method, see \textcite{Schieweck2010, Hussain2011}. Figure~\ref{fig:formulation:petrovgalerkin:petrov1} shows the resulting test basis that is still continuous in space but discontinuous in time. 
Interestingly, this approach reduces to a Crank-Nicolson time-stepping scheme when using the tensor-product of a spatial and a temporal mesh together with a trapezoidal quadrature in time \parencite{Aziz1989}.
The same piecewise discontinuous test space can also be obtained by using the time derivatives of the trial basis as a test basis. While the support of the test functions is larger in this case, both bases can represent the same piecewise constant functions in time, as Figure~\ref{fig:formulation:petrovgalerkin:petrov2} shows. The advantage of this choice is the close relation to the trial functions, which facilitates an implementation into a standard finite element framework and conceptually simplifies the construction of $hp$-test bases.

For high-order finite element interpolations (trial bases), the first approach uses the same (high-order piecewise polynomial) basis functions to test as the trial basis. This thesis uses integrated Legendre polynomials to construct high-order finite elements, as Chapter~\ref{sec:pfem} discusses. The second approach can be extended to higher-order bases by using Legendre polynomials (or any other polynomial basis). Since, conceptually, the test basis seeks to approximate a time derivative of the trial basis, it is discontinuous across the element interfaces in time. It is one degree lower than the trial basis, which is continuous across the element interfaces in time. Therefore, the test functions are again piecewise constants for a linear finite element interpolation. A second-order interpolation yields a constant and a linear test function in time on each element, and so on. Interestingly, this approach reduces the polynomial degree \review{in time} of the second term of the weak form in \eqref{eq:formulation:spacetime:weakform1} to $p \cdot (p - 1)$ instead of $p^2$ for continuous trial and test bases, where $p$ is the polynomial degree of the \review{temporal} finite element interpolation. This allows using only $p$ instead of $p + 1$ Gauss-Legendre quadrature points in time while still integrating the finite element system exactly \review{(for a time-independent material)}. As an alternative to using a local polynomial test basis of degree $p - 1$ on each element, one can again use the time derivative of the trial basis. The resulting functions have a larger support but span the same space.

A major difference between these approaches is how they split into sequential, slab-wise schemes. Figure~\ref{fig:formulation:petrovgalerkin:systems} sketches the linear systems that arise from evaluating the weak form \eqref{eq:formulation:spacetime:weakform1} with different test functions and the piecewise linear trial basis. The \review{matrix and vector} entries correspond to the left- and right-hand sides of \eqref{eq:formulation:spacetime:weakform1}. The first equation system shows how the continuous test basis introduces a coupling across the element interfaces in time, preventing a split into separate systems. In contrast, the piecewise constant test functions (second equation system) are supported on one element only and allow the problem to be solved in three time slabs, containing three elements each. Figure~\ref{fig:formulation:petrovgalerkin:decoupled} shows the decoupled systems that use the solution on the final time slice of the previous slab as initial condition. Lastly, in the third equation system of Figure~\ref{fig:formulation:petrovgalerkin:systems}, the test functions are the time derivatives of the trial functions that again result in a coupling. \review{Interestingly, the time derivative test functions combined with a constant heat source lead to a counter-intuitive right-hand side, where the only non-zero entries originate from the test functions with support on the final (temporal) boundary.}

\begin{figure}[ht!]
\centering
\includeTikz{}{spacetime_system_sequential_petrov1}%
\caption{Sequential solution of the second system in Figure~\ref{fig:formulation:petrovgalerkin:systems} after canceling $1/18$ on both sides of the equation.}
\label{fig:formulation:petrovgalerkin:decoupled}
\end{figure}

\begin{figure}[ht!]
\pgfplotscreateplotcyclelist{colorCycleList}
{%
  {red, mark=square},
  {red, mark=x},
  {blue, mark=square},
  {blue, mark=x},
  {nicegreen, mark=square},
  {nicegreen, mark=x},
  {black, mark=square},
  {black, mark=x}
}
\hspace{0.25cm}
\begin{minipage}[b]{0.46\textwidth}
  \includeTikz{width=\textwidth}{method_comparison_sketch}
  \subcaption{Problem setup}
  \label{fig:formulation:petrovgalerkin:convergence:a}
\end{minipage}
\hfill
\begin{minipage}[b]{0.4\textwidth}
  \hspace{0.27cm}
  \includePng{width=0.8875\textwidth}{method_comparison_solution}
  
  \vspace{0.5cm}
  
  %\hfill
  \includeTikz{}{method_comparison_colorbar}
  \vspace{-0.2cm}%\hspace{0.15cm}
\subcaption{Analytical solution $u_{\text{ex}}$}
\label{fig:formulation:petrovgalerkin:convergence:b}
\end{minipage}
%\hspace{0.3cm}

\vspace{0.7cm}

\hfill
\ref{MethodComparisonLegend}
\vspace{0.2cm}

\begin{minipage}[b]{0.475\textwidth}
  \includeTikz{width=\textwidth}{method_comparison_L2H1}
  \subcaption{$H^1$ norm in space, $L^2$ norm in time}
  \label{fig:formulation:petrovgalerkin:convergence:c}
\end{minipage}
\hspace{0.3cm}
\begin{minipage}[b]{0.485\textwidth}
  \includeTikz{width=\textwidth}{method_comparison_L2L2}
  \subcaption{$L^2$ norm in space and time}
  \label{fig:formulation:petrovgalerkin:convergence:d}
\end{minipage}
\hfill
\caption{Comparison of the error convergence of the continuous and discontinuous test spaces for a linear heat equation in one (space) dimension with a smooth solution.}
\label{fig:formulation:petrovgalerkin:convergence}
\end{figure}

\begin{figure}[ht!]
\hspace{0.3cm}
\begin{minipage}[b]{0.41\textwidth}
  \includeTikz{width=\textwidth}{causality_sketch}
  \subcaption{Problem setup}
\end{minipage}
\hfill
\begin{minipage}[b]{0.478\textwidth}
  \includePng{width=0.763\textwidth}{causality_source}
  \hfill
  \includeTikz{}{causality_colorbar_source}
  \subcaption{Heat source for $\sigma = 0.04$\hspace{1cm}\hphantom{M}}
\end{minipage}

\vspace{0.3cm}

\begin{minipage}[b]{0.32\textwidth}
  \includePng{width=\textwidth}{causality_bubnov_S0p1}
  \subcaption{Continuous $W^h$, $\sigma = 0.1$}
\end{minipage}
\hfill
\begin{minipage}[b]{0.32\textwidth}
  \includePng{width=\textwidth}{causality_bubnov_S0p04}
  \subcaption{Continuous $W^h$, $\sigma = 0.04$}
\end{minipage}
\hfill
\begin{minipage}[b]{0.32\textwidth}
  \includePng{width=\textwidth}{causality_bubnov_S0p01}
  \subcaption{Continuous $W^h$, $\sigma = 0.01$}
\end{minipage}

\vspace{0.3cm}

\begin{minipage}[b]{0.32\textwidth}
  \includePng{width=\textwidth}{causality_petrov_S0p1}
  \subcaption{Discontinuous $W^h$, $\sigma = 0.1$}
\end{minipage}
\hfill
\begin{minipage}[b]{0.32\textwidth}
  \includePng{width=\textwidth}{causality_petrov_S0p04}
  \subcaption{Discontinuous $W^h$, $\sigma = 0.04$}
\end{minipage}
\hfill
\begin{minipage}[b]{0.32\textwidth}
  \includePng{width=\textwidth}{causality_petrov_S0p01}
  \subcaption{Discontinuous $W^h$, $\sigma = 0.01$}
\end{minipage}

\vspace{0.2cm} \centering
\includeTikz{}{causality_colorbar_solution}\hspace{0.2cm}
\vspace{-0.23cm}
  
\caption{Causality violation of the continuous test space for an impulse heat source.}%Spurious oscillations propagate back in time when the resolution at the peak is insufficient.
\label{fig:formulation:petrovgalerkin:causality}
\end{figure}

\review{The piecewise continuous and discontinuous test bases} also \review{behave differently} when compared on a linear heat equation in one spatial dimension. Figure~\ref{fig:formulation:petrovgalerkin:convergence:a} shows a simple benchmark problem setup, and Figure~\ref{fig:formulation:petrovgalerkin:convergence:b} shows the corresponding analytical solution. While the errors of the two space-time methods converge equivalently in the $H^1$ norm in space (Figure~\ref{fig:formulation:petrovgalerkin:convergence:c}), the space-time $L^2$ convergence of the continuous test basis is one order lower for even polynomial degrees (Figure~\ref{fig:formulation:petrovgalerkin:convergence:d}). Figure~\ref{fig:formulation:petrovgalerkin:causality} shows a similar setup with a narrow Gaussian source of varying widths in the center of the space-time domain. The solution interpolation uses $16\times16$ bilinear finite elements. The continuous test basis performs well initially (for $\sigma = 0.1$), but the solution quality deteriorates after decreasing the width of the point source. In particular, the discretization error \review{results in} spurious oscillations \review{that are} non-local and propagate backwards in time. In contrast, the discontinuous test basis performs much better. Although a discretization error is visible, its influence is local and does not violate causality. These observations do not depend on the quadrature order (this example uses $p + 10 = 11$ points per direction). Such sudden onsets or stops of the heat source are very common in \gls*{LPBF}, and suitable discretization methods must provide reasonable approximations even in the pre-asymptotic regime.

The properties outlined in this section motivate choosing a piecewise discontinuous basis with degree $p - 1$ for the space-time discretization of \gls*{LPBF} problems. The remaining task is to find an efficient \review{implementation for} this approach that can be used in a standard finite element framework. The time derivative approach is the most straightforward, but numerical experiments show that it may lead to an ill-conditioned global equation system. The element-local\review{, piecewise discontinuous} polynomial basis does not suffer from this issue, but the resulting element matrices are not square. Moreover, the shape functions must not be connected in time, which interferes with the multi-level $hp$ rules introduced in Chapter~\ref{sec:mlhp}. As a compromise, the time-derivative approach is modified by setting the rows of each element system to zero, that originate from the second shape function (with negative constant derivative). In the linear setting, this recovers the element-local piecewise constant approach: the negative contributions to the functions in Figure~\ref{fig:formulation:petrovgalerkin:petrov2} are set to zero, resulting in the basis shown in Figure~\ref{fig:formulation:petrovgalerkin:petrov1}. The time-derivative of the additional high-order shape functions are element-local in time and do not cause any \review{non-local interactions}. Finally, the explicit zeros in the global equation system are filtered after finishing the assembly and before invoking the solution of the linear equation system.

\CopiedSection{\footnotemark[2]}{Solution of the nonlinear equation system}
\label{sec:formulation:linearization}

The time derivative continuous Galerkin-Petrov method discussed in Section~\ref{sec:formulation:petrovgalerkin} results in the following discrete weak form:\\
Find $u^h \in u_b^h + W^h_0$, such that
\begin{equation} 
    \label{eq:formulation:linearization:discreteweakform}
    \int_{\Omega} \dot{w} \, c \dot{u} + \nabla \dot{w} \cdot \, k \nabla u \; \text{d}\Omega = \int_{\Omega} \dot{w} f \; \text{d}\Omega + \int_{\Gamma_N} \dot{w} \, h \; \text{d} \Gamma_N \qquad \forall w \in W_0(\Omega),
\end{equation}
where $W^h_0$ is a standard continuous finite element space (now including the temporal dimension) with the additional condition that the gradient of the time derivative is defined. This condition on the time derivative excludes elements such as triangles in space-time where the Jacobian matrix of the element mapping is not diagonal (block diagonal in higher dimensions). Still, the continuity of the temporal derivative condition allows for locally refined rectangular elements with hanging nodes, as shown in Figure~\ref{fig:introduction:comparison1D}, for example. 

The temperature dependency of the coefficients $c$ and $k$ renders~\eqref{eq:formulation:linearization:discreteweakform} nonlinear. The solution of the nonlinear finite element system is obtained using standard Newton-Raphson iterations
\begin{align*}
    &\hat{u}^{k + 1} = \hat{u}^{k} + \Delta \hat{u}^{k} \\[0.3em]
    %&\hat{u}^{n + 1, \, k + 1} =\hat{u}^{n + 1, \, k} + \Delta \hat{u}^{n + 1, \, k + 1} \\[0.3em]
    &T_{ij}(\hat{u}^{k}) \, \Delta \hat{u}^{k}_j = -R_{i}(\hat{u}^{k}),
\end{align*}
around the temperature coefficients $\hat{u}^k$. The tangent matrix $T_{ij}(\hat{u}^{k})$ and the residual $R_{i}(\hat{u}^{k})$, evaluated at iteration $k$, are defined as follows:
%
\begin{align} 
    \label{eq:formulation:spacetime:discreteweak}
    R_i(u^h) &= \int_{\Omega} \dot{N}_i \, c \dot{u}^h + \nabla \dot{N}_i \cdot \, k \nabla u^h - \dot{N}_i f \; \text{d}\Omega - \int_{\Gamma_N} \dot{N}_i \, h \; \text{d} \Gamma_N,\\
    \label{eq:formulation:spacetime:linearization}
    T_{ij}(u^h) &= \frac{\partial R_i}{\partial \hat{u}_j} = \int_{\Omega} \dot{N}_i \left ( c \dot{N}_j + c' \dot{u}^h N_j \right ) + \nabla \dot{N}_i \cdot \left ( k \nabla N_j + k' \nabla u^h N_j \right ) \text{d}\Omega,
\end{align}
%
where $c'$ and $k'$ are the derivatives of $c$ and $k$ with respect to temperature. The iterations start at $\hat{u}^0 = 0$ and stop once a reasonable reduction in the residual $\left \lVert R^k \right \rVert < \epsilon \left \lVert R^0 \right \rVert$ is achieved. A value of $\epsilon = 10^{-4}$ was chosen for the computations in this thesis, as smaller values did not improve the solution noticeably. 

The finite element systems are integrated in space with a standard Gauss-Legendre quadrature rule with $p + 1$ points in each spatial direction. As the test functions have a maximum polynomial degree of $p - 1$ in time, it may be sufficient to use only $p$ quadrature points in time to integrate the products of shape functions. However, more quadrature points may be needed around a concentrated heat source as the rapid temperature changes and the material's nonlinearities can make the integrals quite rough. This quadrature inadequacy is especially problematic when using an apparent heat capacity model to account for the phase change, as Section~\ref{sec:formulation:phasechange} discussed.

}